Imports Telerik.WebControls
Imports System.Data.OleDb
Imports System.Data

Partial Class _Default
    Inherits System.Web.UI.Page

    Protected command As OleDbCommand
    Protected con As OleDbConnection

    Private Sub GenerateTreeView()
        Dim dbCon As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Server.MapPath("Tree.mdb"))
        dbCon.Open()

        Dim adapter As New OleDbDataAdapter("SELECT * FROM Links", dbCon)
        Dim ds As New DataSet
        adapter.Fill(ds)

        ds.Relations.Add("NodeRelation", ds.Tables(0).Columns("id"), ds.Tables(0).Columns("parentId"))

        Dim dbRow As DataRow
        For Each dbRow In ds.Tables(0).Rows
            If dbRow.IsNull("parentId") Then
                Dim node As RadTreeNode = CreateNode(dbRow("Text").ToString(), True)
                RadTree1.Nodes.Add(node)
                RecursivelyPopulate(dbRow, node)
            End If
        Next dbRow
    End Sub 'GenerateTreeView

    Private Sub RecursivelyPopulate(ByVal dbRow As DataRow, ByVal node As RadTreeNode)
        Dim childRow As DataRow
        For Each childRow In dbRow.GetChildRows("NodeRelation")
            Dim childNode As RadTreeNode = CreateNode(childRow("Text").ToString(), True)
            node.Nodes.Add(childNode)
            RecursivelyPopulate(childRow, childNode)
        Next childRow
    End Sub 'RecursivelyPopulate


    Protected Sub Page_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        If Not Page.IsPostBack Then
            GenerateTreeView()
        End If
    End Sub

    Protected Sub RadTree1_NodeEdit(ByVal o As Object, ByVal e As Telerik.WebControls.RadTreeNodeEventArgs) Handles RadTree1.NodeEdit
        Dim edit As RadTreeNode = e.NodeEdited
        Dim [text] As String = e.NewText
        edit.Text = [text]
    End Sub

    Protected Sub Button1_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Button1.Click
        con = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Server.MapPath("Tree.mdb"))
        con.Open()
        command = New OleDbCommand("DELETE * from Links", con)
        command.ExecuteNonQuery()
        con.Close()
        UpdateNodes()
    End Sub

    Private Function CreateNode(ByVal [text] As String, ByVal expanded As Boolean) As RadTreeNode
        Dim node As New RadTreeNode([text])
        node.Expanded = True

        Return node
    End Function 'CreateNode

    Private Sub UpdateNodes()
        Dim con As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" + Server.MapPath("Tree.mdb"))
        con.Open()

        Dim allNodes As ArrayList = RadTree1.GetAllNodes()
        Dim i As Integer
        For i = 0 To allNodes.Count - 1
            Dim node As RadTreeNode = CType(allNodes(i), RadTreeNode)
            Dim parentId As Integer = allNodes.IndexOf(node.Parent)

            command = New OleDbCommand("INSERT into Links([id],parentId,[Text]) values (@ID,@parentId,@Text)", con)
            command.Parameters.AddWithValue("ID", i.ToString())
            If parentId > -1 Then
                command.Parameters.AddWithValue("parentId", parentId)
            Else
                command.Parameters.AddWithValue("parentId", System.DBNull.Value)
            End If
            command.Parameters.AddWithValue("Text", node.Text)
            command.ExecuteNonQuery()
        Next i
        con.Close()
    End Sub 'UpdateNodes  
   
End Class
